? data-list.patch
Index: ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/ChangeLog,v
retrieving revision 1.61
diff -u -p -u -r1.61 ChangeLog
--- ChangeLog	12 Jul 2006 20:41:29 -0000	1.61
+++ ChangeLog	17 Jul 2006 04:09:50 -0000
@@ -1,3 +1,7 @@
+Sun Jul 16 19:51:45 2006  Ben Pfaff  <blp@gnu.org>
+
+	* Smake: Add xsize to GNULIB_MODULES.
+
 Wed Jul 12 13:41:18 2006  Ben Pfaff  <blp@gnu.org>
 
 	* Makefile.am: Add check_PROGRAMS and define to empty.
Index: Smake
===================================================================
RCS file: /cvsroot/pspp/pspp/Smake,v
retrieving revision 1.35
diff -u -p -u -r1.35 Smake
--- Smake	3 Jul 2006 01:38:24 -0000	1.35
+++ Smake	17 Jul 2006 04:09:50 -0000
@@ -51,6 +51,7 @@ GNULIB_MODULES = \
 	xalloc \
 	xalloc-die \
 	xreadlink \
+	xsize \
 	xstrndup \
 	xvasprintf
 
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.59
diff -u -p -u -r1.59 ChangeLog
--- src/data/ChangeLog	14 Jul 2006 02:28:29 -0000	1.59
+++ src/data/ChangeLog	17 Jul 2006 04:09:50 -0000
@@ -1,3 +1,23 @@
+Sun Jul 16 19:52:03 2006  Ben Pfaff  <blp@gnu.org>
+
+	* format.c: (fmt_type_from_string) New function.
+	(fmt_to_string) Include decimals in output if the format has
+	decimals, even if the format type does not.  This way, we can
+	accurately reproduce incorrect formats in user output.
+	(check_common_specifier) Make the check for a bad format type an
+	assertion, so we get bug reports if they show up.  Fix message.
+	Check for decimal places with a format type that doesn't allow
+	them.
+	(check_input_specifier) Remove check for FMT_X, which has been
+	deleted.
+	(check_output_specifier) Ditto.	
+
+	* format.def: Remove FMT_T, FMT_X, FMT_DESCEND, FMT_NEWREC.
+
+	* format.h: (macro FMT_TYPE_LEN_MAX) New macro.
+	(struct fmt_desc) Use FMT_TYPE_LEN_MAX in definition.
+	(enum fmt_parse_flags) Removed.
+
 Wed Jul 12 21:02:26 2006  Ben Pfaff  <blp@gnu.org>
 
 	* procedure.c (internal_procedure): Create sink_case with only as
Index: src/data/format.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.c,v
retrieving revision 1.7
diff -u -p -u -r1.7 format.c
--- src/data/format.c	8 Jul 2006 03:05:51 -0000	1.7
+++ src/data/format.c	17 Jul 2006 04:09:51 -0000
@@ -44,14 +44,34 @@ struct fmt_desc formats[FMT_NUMBER_OF_FO
 /* Common formats. */
 const struct fmt_spec f8_2 = {FMT_F, 8, 2};
 
+/* Tries to parse NAME as a format type.
+   If successful, stores the type in *TYPE and returns true.
+   On failure, returns false. */
+bool
+fmt_type_from_string (const char *name, int *type) 
+{
+  int i;
+
+  for (i = 0; i < FMT_NUMBER_OF_FORMATS; i++)
+    if (!strcasecmp (name, formats[i].name))
+      {
+        *type = i;
+        return true;
+      }
+  return false;
+}
+
 /* Converts F to its string representation (for instance, "F8.2") and
-   returns a pointer to a static buffer containing that string. */
+   returns a pointer to a static buffer containing that string.
+   If F has decimals, then they are included in the output
+   string, even if F's format type does not, so that we can
+   accurately present incorrect formats to the user. */
 char *
 fmt_to_string (const struct fmt_spec *f)
 {
   static char buf[32];
 
-  if (formats[f->type].n_args >= 2)
+  if (formats[f->type].n_args >= 2 || f->d > 0)
     sprintf (buf, "%s%d.%d", formats[f->type].name, f->w, f->d);
   else
     sprintf (buf, "%s%d", formats[f->type].name, f->w);
@@ -68,14 +88,7 @@ check_common_specifier (const struct fmt
   struct fmt_desc *f ; 
   char *str;
 
-  if ( spec->type > FMT_NUMBER_OF_FORMATS ) 
-    {
-      if (emit_error)
-        msg (SE, _("Format specifies a bad type (%d)"), spec->type);
-      
-      return false;
-    }
-
+  assert (spec->type < FMT_NUMBER_OF_FORMATS);
   f = &formats[spec->type];
   str = fmt_to_string (spec);
 
@@ -91,10 +104,18 @@ check_common_specifier (const struct fmt
     {
       if (emit_error)
         msg (SE, _("Format %s specifies a bad number of "
-                   "implied decimal places %d.  Input format %s allows "
+                   "implied decimal places %d.  Format type %s allows "
                    "up to 16 implied decimal places."), str, spec->d, f->name);
       return false;
     }
+  if (f->n_args <= 1 && spec->d) 
+    {
+      if (emit_error)
+        msg (SE, _("Format %s specifies %d decimal places, but "
+                   "format type %s does not allow for decimal places."),
+             str, spec->d, f->name);
+      return false;
+    }
   return true;
 }
 
@@ -104,7 +125,7 @@ check_common_specifier (const struct fmt
 int
 check_input_specifier (const struct fmt_spec *spec, int emit_error)
 {
-  struct fmt_desc *f ;
+  struct fmt_desc *f;
   char *str ;
 
   if (!check_common_specifier (spec, emit_error))
@@ -112,10 +133,6 @@ check_input_specifier (const struct fmt_
 
   f = &formats[spec->type];
   str = fmt_to_string (spec);
-
-
-  if (spec->type == FMT_X)
-    return 1;
   if (f->cat & FCAT_OUTPUT_ONLY)
     {
       if (emit_error)
@@ -156,9 +173,6 @@ check_output_specifier (const struct fmt
 
   f = &formats[spec->type];
   str = fmt_to_string (spec);
-
-  if (spec->type == FMT_X)
-    return 1;
   if (spec->w < f->Omin_w || spec->w > f->Omax_w)
     {
       if (emit_error)
Index: src/data/format.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.def,v
retrieving revision 1.2
diff -u -p -u -r1.2 format.def
--- src/data/format.def	2 May 2006 03:51:43 -0000	1.2
+++ src/data/format.def	17 Jul 2006 04:09:51 -0000
@@ -57,9 +57,3 @@ DEFFMT (FMT_TIME,	  "TIME",      2,  5, 
 DEFFMT (FMT_DTIME,	  "DTIME",     2, 11,  40,  8,   40, 0001, FMT_DTIME, 25)
 DEFFMT (FMT_WKDAY,	  "WKDAY",     1,  2,  40,  2,   40, 0001, FMT_WKDAY, 26)
 DEFFMT (FMT_MONTH,	  "MONTH",     1,  3,  40,  3,   40, 0001, FMT_MONTH, 27)
-			  					     
-/* These aren't real formats.  They're used by DATA LIST. */	     
-DEFFMT (FMT_T,            "T",         1,  1,99999, 1,99999, 0000, FMT_T, -1)
-DEFFMT (FMT_X,		  "X",         1,  1,99999, 1,99999, 0000, FMT_X, -1)
-DEFFMT (FMT_DESCEND,      "***",       1,  1,99999, 1,99999, 0000, -1, -1)
-DEFFMT (FMT_NEWREC,	  "***",       1,  1,99999, 1,99999, 0000, -1, -1)
Index: src/data/format.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/format.h,v
retrieving revision 1.3
diff -u -p -u -r1.3 format.h
--- src/data/format.h	31 May 2006 07:38:03 -0000	1.3
+++ src/data/format.h	17 Jul 2006 04:09:51 -0000
@@ -39,10 +39,14 @@ enum
   };
 #undef DEFFMT
 
+/* Length of longest format specifier name,
+   not including terminating null. */
+#define FMT_TYPE_LEN_MAX 8
+
 /* Describes one of the display formats above. */
 struct fmt_desc
   {
-    char name[9];		/* `DATETIME' is the longest name. */
+    char name[FMT_TYPE_LEN_MAX + 1]; /* Name, in all caps. */
     int n_args;			/* 1=width; 2=width.decimals. */
     int Imin_w, Imax_w;		/* Bounds on input width. */
     int Omin_w, Omax_w;		/* Bounds on output width. */
@@ -101,13 +105,6 @@ union value;
 /* Maximum length of formatted value, in characters. */
 #define MAX_FORMATTED_LEN 256
 
-/* Flags for parsing formats. */
-enum fmt_parse_flags
-  {
-    FMTP_ALLOW_XT = 001,                /* 1=Allow X and T formats. */
-    FMTP_SUPPRESS_ERRORS = 002          /* 1=Do not emit error messages. */
-  };
-
 /* Common formats. */
 extern const struct fmt_spec f8_2;      /* F8.2. */
 
@@ -122,6 +119,7 @@ int parse_string_as_format (const char *
 			    int fc, union value *v);
 int translate_fmt (int spss);
 bool data_out (char *s, const struct fmt_spec *fp, const union value *v);
+bool fmt_type_from_string (const char *name, int *type);
 char *fmt_to_string (const struct fmt_spec *);
 void num_to_string (double v, char *s, int w, int d);
 struct fmt_spec make_input_format (int type, int w, int d);
Index: src/language/data-io/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/ChangeLog,v
retrieving revision 1.24
diff -u -p -u -r1.24 ChangeLog
--- src/language/data-io/ChangeLog	5 Jul 2006 05:14:30 -0000	1.24
+++ src/language/data-io/ChangeLog	17 Jul 2006 04:09:51 -0000
@@ -1,3 +1,20 @@
+Sun Jul 16 19:57:10 2006  Ben Pfaff  <blp@gnu.org>
+
+	* automake.mk: (src_language_data_io_libdata_io_a_SOURCE) Add
+	print-space.c, placement-parser.c, placement-parser.h.
+
+	* data-list.c: Basically rewrote the whole thing.  Broke out a lot
+	of code into placement-parser.c.  Code is much cleaner now.
+
+	* placement-parser.c: New file.
+
+	* placement-parser.h: New file.
+
+	* print.c: Basically rewrote the whole thing.  Broke out PRINT
+	SPACE into print-space.c.  Code is much cleaner now.
+
+	* print-space.c: New file.
+
 Sat Jul  1 17:39:40 2006  Ben Pfaff  <blp@gnu.org>
 
 	Fix bug #11612, "q2c documentation does not agree with code".
Index: src/language/data-io/automake.mk
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/automake.mk,v
retrieving revision 1.6
diff -u -p -u -r1.6 automake.mk
--- src/language/data-io/automake.mk	15 Jul 2006 04:38:57 -0000	1.6
+++ src/language/data-io/automake.mk	17 Jul 2006 04:09:51 -0000
@@ -8,12 +8,15 @@ src_language_data_io_libdata_io_a_SOURCE
 	src/language/data-io/inpt-pgm.c \
 	src/language/data-io/inpt-pgm.h \
 	src/language/data-io/print.c \
+	src/language/data-io/print-space.c \
 	src/language/data-io/matrix-data.c   \
 	src/language/data-io/data-reader.c \
 	src/language/data-io/data-reader.h \
 	src/language/data-io/data-writer.c \
 	src/language/data-io/data-writer.h \
-	src/language/data-io/file-handle.h
+	src/language/data-io/file-handle.h \
+	src/language/data-io/placement-parser.c \
+	src/language/data-io/placement-parser.h
 
 src_language_data_io_built_sources = \
 	src/language/data-io/file-handle.c \
